From 54ec62936ca84a3744dbcdb761a088a6953ef0ad Mon Sep 17 00:00:00 2001
From: "kuroda.hayato%40jp.fujitsu.com" <kuroda.hayato@jp.fujitsu.com>
Date: Wed, 21 Sep 2022 06:52:23 +0000
Subject: [PATCH v21 3/3] add test

Note that this test has two comparison files. Alternative comparison file is needed
because some platforms like Windows cannot check the status of the socket.
---
 .../postgres_fdw/expected/postgres_fdw.out    |    44 +
 .../postgres_fdw/expected/postgres_fdw_1.out  | 11746 ++++++++++++++++
 contrib/postgres_fdw/sql/postgres_fdw.sql     |    30 +
 3 files changed, 11820 insertions(+)
 create mode 100644 contrib/postgres_fdw/expected/postgres_fdw_1.out

diff --git a/contrib/postgres_fdw/sql/postgres_fdw.sql b/contrib/postgres_fdw/sql/postgres_fdw.sql
index bfcac4ea14..bd7f249f25 100644
--- a/contrib/postgres_fdw/sql/postgres_fdw.sql
+++ b/contrib/postgres_fdw/sql/postgres_fdw.sql
@@ -3876,3 +3876,33 @@ SELECT * FROM prem2;
 
 ALTER SERVER loopback OPTIONS (DROP parallel_commit);
 ALTER SERVER loopback2 OPTIONS (DROP parallel_commit);
+
+-- ===================================================================
+-- test for postgres_fdw_verify_foreign_servers function
+-- ===================================================================
+
+-- Disable debug_discard_caches in order to manage remote connections
+SET debug_discard_caches TO '0';
+
+-- Disconnect once and set application_name to an arbitrary value
+SELECT 1 FROM postgres_fdw_disconnect_all();
+ALTER SERVER loopback OPTIONS (SET application_name 'healthcheck');
+
+-- The text of the error might vary across platforms, so only show SQLSTATE.
+\set VERBOSITY sqlstate
+
+BEGIN;
+SELECT 1 FROM ft1 LIMIT 1;
+-- Terminate the remote backend process
+SELECT pg_terminate_backend(pid, 180000) FROM pg_stat_activity
+       WHERE application_name = 'healthcheck';
+
+-- execute check function. This should return false on supported platforms,
+-- otherwise return true.
+SELECT postgres_fdw_verify_connection_states('loopback');
+ABORT;
+
+\set VERBOSITY default
+
+-- Clean up
+RESET debug_discard_caches;
-- 
2.27.0

